package de.mdelab.mlsdm.interpreter.debug.ui.launcher;

import java.io.OutputStream;
import java.util.List;
import java.util.Map;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.resource.Resource;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.interpreter.debug.MLSDMInterpreterLauncher;
import de.mdelab.mlsdm.interpreter.eclipse.MLSDMEclipseInterpreterLauncher;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.SDServerThread;
import de.mdelab.sdm.interpreter.core.debug.SDInterpreterLauncher;
import de.mdelab.sdm.interpreter.core.variables.Variable;

public class MLSDMServerThread extends SDServerThread<Activity, EClassifier> {
	
	public MLSDMServerThread( 	final Activity p_activity,
								final List<Variable<EClassifier>> p_variableBindings,
								final Integer p_serverPort,
								final Integer p_resourceSetSynchronizerPort,
								final IProgressMonitor p_monitor,
								final OutputStream p_messageStream,
								final Map<Resource, URI> p_instanceModels,
								final boolean pb_logOutput,
								final String p_execTraceUriStr ) {
		super( p_activity, p_variableBindings, p_serverPort, p_resourceSetSynchronizerPort, p_monitor, p_messageStream, p_instanceModels, pb_logOutput, p_execTraceUriStr );
	}

	@Override
	protected SDInterpreterLauncher<?, Activity, EClassifier> createLauncher() {
		if ( Platform.isRunning() ) {
			return new MLSDMEclipseInterpreterLauncher();
		}
		
		return new MLSDMInterpreterLauncher();
	}
}
