package de.mdelab.mlsdm.interpreter.debug.ui.launcher.table;

import java.util.Map;
import java.util.Set;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Composite;

import de.mdelab.mlsdm.Activity;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.actparameter.SDActivityParameterTableViewer;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.actparameter.SDInstanceObjectEditingSupport;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.actparameter.SDTableActivityParameterData;

/**
 * Table to edit story diagram activity parameters for Eclipse launch configuration
 */
public class MLSDMActivityParameterTableViewer extends SDActivityParameterTableViewer<Activity, MLSDMTableActivityParameter, EClassifier> {

	/**
	 * @param parent
	 */
	public MLSDMActivityParameterTableViewer( final Composite p_parent ) {
		super( p_parent );
	}

	@Override
	protected SDTableActivityParameterData<Activity, MLSDMTableActivityParameter> createTableData() {
		return new MLSDMTableActivityParameterData();
	}

	@Override
	protected SDInstanceObjectEditingSupport<MLSDMTableActivityParameter, EClassifier> createInstanceObjectsEditingSupport( final TableViewer p_tableViewer,
																															final ILabelProvider p_labelProvider ) {
		return new MLSDMInstanceObjectsEditingSupport( p_tableViewer, p_labelProvider );
	}
	
	@Override
	public void initData( 	final Activity p_activity,
							final Set<Resource> p_instanceObjectRes,
							final Map<String, String> p_rowData ) {
		final ResourceSet resSet = p_instanceObjectRes.isEmpty() ? null : p_instanceObjectRes.iterator().next().getResourceSet();
		getTableData().initData( p_activity, p_rowData, resSet );
		
		super.initData( p_activity, p_instanceObjectRes, p_rowData);
	}
	
	@Override
	public void initData( 	final Activity p_activity,
							final Set<Resource> p_instanceObjectRes ) {
		getTableData().initData( p_activity );

		super.initData( p_activity, p_instanceObjectRes );
	}
	
	@Override
	public MLSDMTableActivityParameterData getTableData() {
		return (MLSDMTableActivityParameterData) super.getTableData();
	}
}