package de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor;


import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDocumentProvider;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.part.ShowInContext;

import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditor;

public class MLSDMDebuggerStoryDiagramEditor extends MlsdmDiagramEditor {
	
	public static final String ID = "de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMDebuggerStoryDiagramEditor.ID";	//$NON-NLS-1$
	
	// DB: Use variable from super class
	//private MLSDMDebuggerDocumentProvider	documentProvider;

	@Override
	protected IDocumentProvider getDocumentProvider( final IEditorInput p_input )	{
		//assert input instanceof MLSDMDebuggerResourceEditorInput;

		if ( getDocumentProvider() == null )	{
			setDocumentProvider( p_input );
		}

		return getDocumentProvider();
	}

	@Override
	protected void setDocumentProvider( final IEditorInput p_input ) {
		if ( p_input instanceof MLSDMDebuggerEditorInput ) {
			setDocumentProvider( new MLSDMDebuggerDocumentProvider( ( ( MLSDMDebuggerEditorInput ) p_input ).getDebugTarget() ) );
		}
		else {
			super.setDocumentProvider( p_input );
		}
	}
//
//	@Override
//	public boolean isSaveAsAllowed()
//	{
//		return false;
//	}
//
//	@Override
//	public void doSaveAs()
//	{
//		throw new UnsupportedOperationException();
//	}
//
//	@Override
//	public void doSave(IProgressMonitor progressMonitor)
//	{
//		super.doSave(progressMonitor);
//	}
//
//	@Override
//	protected void performSave(boolean overwrite, IProgressMonitor progressMonitor)
//	{
//		super.performSave(overwrite, progressMonitor);
//	}

//	@Override
//	protected void performSaveAs(IProgressMonitor progressMonitor)
//	{
//		// Do nothing
//	}

	@Override
	public ShowInContext getShowInContext()
	{
		return null;
	}

//	@Override
//	public boolean isDirty()
//	{
//		return false;
//	}

	@Override
	public boolean isEditorInputModifiable()
	{
		return true;
	}

	@Override
	public boolean isEditable()
	{
		return true;
	}

	@Override
	public boolean isEditorInputReadOnly()
	{
		return false;
	}
//
//	@Override
//	public boolean isSaveOnCloseNeeded()
//	{
//		return false;
//	}

	@Override
	public boolean isWritable()
	{
		return true;
	}

	@Override
	public TransactionalEditingDomain getEditingDomain() {
		final IEditorInput editorInput = getEditorInput();
		
		if ( editorInput instanceof MLSDMDebuggerEditorInput ) {
	 		final EditingDomain editDomain = ( (MLSDMDebuggerEditorInput) editorInput ).getEditingDomain();
			
			if ( editDomain instanceof TransactionalEditingDomain ) {
				return (TransactionalEditingDomain) editDomain;
			}
		}
		
		return super.getEditingDomain();
	}
}
